/*

Politecnico di Torino - Fondamenti di Informatica (06AZN)

una possibile soluzione del tema d'esame del 7/9/2010

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* lunghezza sigla del volo, es. AZ4321 */
#define LSIGLA 6

/* lunghezza nome file del volo (sigla volo + ".txt" */
#define LFILE (LSIGLA+4)

/* max lunghezza riga del file */
#define MAXBC 127


FILE *my_fopen (char *fname, char *fmode)
{
   FILE *fp;

   if ((fp = fopen(fname,fmode)) == NULL) {
      fprintf (stderr, "errore - impossibile aprire il file %s in modo '%s'\n",
         fname, fmode);
      exit (1);
   }
   return fp;
}


void my_fclose  (FILE *fp, char *fname)
{
   if (fclose(fp) != 0)
   {
      fprintf (stderr, "avviso - impossibile chiudere il file '%s'\n", fname);
      fprintf (stderr, "(potrebbe quindi essere incompleto o inaccessibile)");
   }
}


int main (int argc, char *argv[])
{
   FILE *fvolo;
   char filename[LFILE+1];
   char buf[MAXBC+1];
   int nriga = 0;
   int nposti_totale, nposti_occupati, nposti_liberi, nposti_richiesti;

   /*
   controllo che ci sia almeno la sigla del volo ed un passeggero da prenotare
   */

   if (argc < 3) {
      fprintf (stderr, "errore - uso: %s sigla_volo passeggeri...\n", argv[0]);
      exit(1);
   }

   if (strlen(argv[1]) != LSIGLA) {
      fprintf (stderr, "errore - sigla del volo non valida (%s)\n", argv[1]);
      exit(1);
   }

   /* creo il nome del file del volo, derivandolo dalla sigla del volo */

   sprintf (filename, "%s.txt", argv[1]);

   /* leggo il file del volo per calcolare quanti posti liberi ci sono */

   fvolo = my_fopen (filename, "r");
   while (fgets(buf,MAXBC,fvolo) != NULL)
   {
      nriga++;
      /* la prima riga contiene il numero di posti totali sul volo */
      if (nriga == 1)
      {
         if (sscanf(buf,"%d",&nposti_totale) != 1)
         {
            fprintf (stderr, "errore - manca il numero di posti nel file '%s'\n", filename);
            exit(1);
         }

      }
      /* le altre righe contengono un passeggero per riga */
      else
         nposti_occupati++;
   }
   my_fclose (fvolo, filename);

   /* calcolo quanti posti sono liberi */

   nposti_liberi = nposti_totale - nposti_occupati;

   /*
   sottraggo il nome del programma e la sigla del volo:
   tutti gli altri argomenti sono passeggeri da prenotare
   */

   nposti_richiesti = argc - 2;

   /* controllo se i posti richiesti sono disponibili */

   if (nposti_richiesti > nposti_liberi)
   {
      printf ("Impossibile prenotare n.%d posti sul volo %s: ", nposti_richiesti, argv[1]);
      printf ("disponibili solo n.%d posti\n", nposti_liberi);
   }
   /* aggiungo i passeggeri nel file del volo e ne presento i nomi in output*/
   else
   {
      int i;
      printf ("Prenotati n.%d posti sul volo %s per", nposti_richiesti, argv[1]);
      fvolo = my_fopen (filename, "a");
      for (i=2; i<argc; i++)
      {
         printf (" %s", argv[i]);
         fprintf (fvolo, "%s\n", argv[i]);
      }
      printf ("\n");
      my_fclose (fvolo, filename);
   }
   
   /* fine del lavoro */

   return 0;
}
